> This page is for Taurus PROTECT, version v3.40.
> For other versions, use one of these documentation indexes:
> - v3.58 (default): https://taurushq.ferndocs.com/protect-capital/v3.58/llms.txt
> - v3.56: https://taurushq.ferndocs.com/protect-capital/v3.56/llms.txt
> - v3.54: https://taurushq.ferndocs.com/protect-capital/v3.54/llms.txt
> - v3.52: https://taurushq.ferndocs.com/protect-capital/v3.52/llms.txt
> - v3.50: https://taurushq.ferndocs.com/protect-capital/v3.50/llms.txt
> - v3.48: https://taurushq.ferndocs.com/protect-capital/v3.48/llms.txt
> - v3.46: https://taurushq.ferndocs.com/protect-capital/v3.46/llms.txt
> - v3.44: https://taurushq.ferndocs.com/protect-capital/v3.44/llms.txt
> - v3.42: https://taurushq.ferndocs.com/protect-capital/v3.42/llms.txt
> - v3.40: https://taurushq.ferndocs.com/protect-capital/v3.40/llms.txt
> - v3.38: https://taurushq.ferndocs.com/protect-capital/v3.38/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://taurushq.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://taurushq.ferndocs.com/_mcp/server.

# List actions

GET https://your-protect-instance.example.com/api/rest/v1/actions

This endpoint lists all actions.
 Required role: **Admin** or **AdminReadOnly**.

Reference: https://taurushq.ferndocs.com/protect-capital/reference/actions/list

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Query parameters

- `limit` (long, optional)
- `offset` (long, optional)
- `ids` (list of string, optional)

## Response

### 200

A successful response.

- `result` (list of tgvalidatordActionEnvelope, optional)
- `totalItems` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request: indicates that the server cannot or will not process the request due to something that is perceived to be a client error (for example, malformed request syntax, invalid request message framing, or deceptive request routing)

- `any`

### 401 Unauthorized Error

Unauthorized: indicates that the client request has not been completed because it lacks valid authentication credentials for the requested resource

- `any`

### 403 Forbidden Error

Forbidden: indicates that the server understands the request but refuses to authorize it

- `any`

### 404 Not Found Error

Not Found: indicates that the server cannot find the requested resource

- `any`

### 500 Internal Server Error

Internal Server Error: indicates that the server encountered an unexpected condition that prevented it from fulfilling the request

- `any`

### 503 Service Unavailable Error

Service Unavailable: indicates that the server is not ready to handle the request.

- `any`

## Types

### tgvalidatordActionEnvelope

- `id` (string, optional)
- `tenantId` (string, optional)
- `label` (string, optional)
- `action` (tgvalidatordAction, optional)
- `status` (string, optional)
- `creationDate` (datetime, optional)
- `updateDate` (datetime, optional)
- `lastcheckeddate` (datetime, optional)
- `autoApprove` (boolean, optional)
- `attributes` (list of tgvalidatordActionAttribute, optional)
- `trails` (list of tgvalidatordActionEnvelopeTrail, optional)

### tgvalidatordAction

- `trigger` (ActionTrigger, optional)
- `tasks` (list of ActionTask, optional)

### tgvalidatordActionAttribute

- `id` (string, optional)
- `tenantId` (string, optional)
- `key` (string, optional)
- `value` (string, optional)
- `contentType` (string, optional)

### tgvalidatordActionEnvelopeTrail

- `id` (string, optional)
- `action` (string, optional)
- `comment` (string, optional)
- `date` (datetime, optional)
- `actionStatus` (string, optional)

### ActionTrigger

- `kind` (string, optional)
- `balance` (Trigger_Balance, optional)

### ActionTask

- `kind` (string, optional)
- `transfer` (Task_Transfer, optional)
- `notification` (Task_Notification, optional)

### Trigger_Balance

- `target` (ActionTarget, optional)
- `comparator` (ActionComparator, optional)
- `amount` (tgvalidatordActionAmount, optional)

### Task_Transfer

- `from` (tgvalidatordActionSource, optional)
- `to` (tgvalidatordActionDestination, optional)
- `amount` (tgvalidatordActionAmount, optional)
- `topUp` (boolean, optional)
- `useAllFunds` (boolean, optional)

### Task_Notification

- `emailAddresses` (list of string, optional)
- `notificationMessage` (string, optional)
- `numberOfReminders` (string, optional)

### ActionTarget

- `kind` (string, optional)
- `address` (Target_Address, optional)
- `wallet` (Target_Wallet, optional)

### ActionComparator

- `kind` (string, optional)

### tgvalidatordActionAmount

- `kind` (string, optional)
- `cryptoAmount` (string, optional)

### tgvalidatordActionSource

- `kind` (string, optional)
- `addressID` (string, optional)
- `walletID` (string, optional)

### tgvalidatordActionDestination

- `kind` (string, optional)
- `addressID` (string, optional)
- `whitelistedAddressID` (string, optional)
- `walletID` (string, optional)

### Target_Address

- `kind` (string, optional)
- `addressID` (string, optional)

### Target_Wallet

- `kind` (string, optional)
- `walletID` (string, optional)

## Examples

**Response**

```json
{
  "result": [
    {
      "id": "string",
      "tenantId": "string",
      "label": "string",
      "action": {
        "trigger": {
          "kind": "string",
          "balance": {
            "target": {
              "kind": "string",
              "address": {
                "kind": "string",
                "addressID": "string"
              },
              "wallet": {
                "kind": "string",
                "walletID": "string"
              }
            },
            "comparator": {
              "kind": "string"
            },
            "amount": {
              "kind": "string",
              "cryptoAmount": "string"
            }
          }
        },
        "tasks": [
          {
            "kind": "string",
            "transfer": {
              "from": {
                "kind": "string",
                "addressID": "string",
                "walletID": "string"
              },
              "to": {
                "kind": "string",
                "addressID": "string",
                "whitelistedAddressID": "string",
                "walletID": "string"
              },
              "amount": {
                "kind": "string",
                "cryptoAmount": "string"
              },
              "topUp": true,
              "useAllFunds": true
            },
            "notification": {
              "emailAddresses": [
                "string"
              ],
              "notificationMessage": "string",
              "numberOfReminders": "string"
            }
          }
        ]
      },
      "status": "string",
      "creationDate": "2024-01-15T09:30:00Z",
      "updateDate": "2024-01-15T09:30:00Z",
      "lastcheckeddate": "2024-01-15T09:30:00Z",
      "autoApprove": true,
      "attributes": [
        {
          "id": "string",
          "tenantId": "string",
          "key": "string",
          "value": "string",
          "contentType": "string"
        }
      ],
      "trails": [
        {
          "id": "string",
          "action": "string",
          "comment": "string",
          "date": "2024-01-15T09:30:00Z",
          "actionStatus": "string"
        }
      ]
    }
  ],
  "totalItems": "string"
}
```

**SDK Code**

```python
import requests

url = "https://your-protect-instance.example.com/api/rest/v1/actions"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://your-protect-instance.example.com/api/rest/v1/actions';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://your-protect-instance.example.com/api/rest/v1/actions"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://your-protect-instance.example.com/api/rest/v1/actions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://your-protect-instance.example.com/api/rest/v1/actions")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://your-protect-instance.example.com/api/rest/v1/actions', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://your-protect-instance.example.com/api/rest/v1/actions");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://your-protect-instance.example.com/api/rest/v1/actions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```